/**
 * 关于坐标系转换问题？
   1、输入和输出统一用84坐标：
        结果：无法实现
        原因：每次输出数据需要调用服务器接口进行转换，nMap和系统服务产生耦合性，如果系统服务产生问题后，NMap将无法使用
   2、输入统一用84坐标系，输出按地图坐标系
        结果：无法实现
        原因：所有输入数据都按84坐标系处理，数据库的数据为84坐标系，转为地图坐标系无问题；但存在手动操作地图时，数据为地图坐标系，也按84坐标系处理经纬度，输出的点和操作的点位置会产生偏移。
 */

//对path进行处理，得到最新的path
let obj = {
  //初始化一个地图对象
  create({ id, scale, toolbar, overview, maptype, callback }) {
    //参数为Object：
    //id:[String]类型，地图容器的id,【必填】
    //scale（比例尺）,toolbar（工具条）,overview（鹰眼）maptype(卫星图图层切换) :[Boolean]添加地图控件，【可选】
    //callback:[Function]地图对象创建完的回调，【可选】
  },
  //线路地图
  destroy() {
    //返回实例对象 对象如下
    //var obj = {
    //    obj: obj,
    //    search: func,
    //    setLevel: func,
    //    setSubdistrict:func
    //}

  },
  //行政区查询实例
  districtSearch() {

  },
  //清除地图上所有覆盖物
  clearMap() { },
  //添加覆盖物
  add(array) {
    //array:[Array]覆盖物对象数组[overlay1, overlay2]
  },
  //移除覆盖物
  remove(array) {
    //array:[Array]覆盖物对象数组[overlay1, overlay2]
  },
  //设置中心城市
  setCity(name, callback) {
    //name：[String]城市名称
    //callback:设置后的回调
  },
  //设置中心点和缩放级别
  zoomAndCenter(zoom, center) {
    //zoom:[Number]地图缩放级别
    //center:[LngLat]类型，地图坐标
  },
  //设置地图缩放
  setZoom(num) { },
  //设置地图中心
  setCenter(lnglat) { },
  //获取地图中心点
  getCenter() {
    //返回LngLat坐标对象
  },
  //获取地图缩放级别
  getZoom() {
    //返回Number类型
  },
  //通过坐标获取地址
  getAddress({ lnglat, callback }) {
    //callback 参数 function(status:String,result:info/ReGeocodeResult)
    //根据给定坐标进行解析
    //当status为complete时，result为ReGeocodeResult；
    //当status为error时，result为错误信息info；
    //当status为no_data时，代表检索返回0结果
  },
  //创建坐标对象
  lngLat(lng, lat) {
    //lng:[Number]经度
    //lat:[Number]纬度
    //返回经纬度坐标对象
    return
    {
      //lng: 0,
      //  lat:0,
      //_mapobj: { },
    };
  },
  //创建像素坐标对象
  newPixel({ x, y }) {
    //返回像素坐标对象
    return Pixel
  },
  //创建Mark对象
  newMark({ lng, lat, icon, offset, label, title }) {
    //参数为Object
    //lng:[Number]经度，【必填】
    //lat:[Number]纬度，【必填】
    //icon:[String],图标地址【可选】
    //offset:[Pixel]像素坐标对象，偏移量
    //label(文本标注)，title(鼠标划过的提示)，

    //返回点标记对象
    return marker;
    //marker 有currentObj，getOffset，setOffset，currentObj，getPosition，setPosition属性和方法
  },
  //设置标记点位置
  setMarkPosition({ obj, lnglat }) { },
  //设置标记点label
  setMarkLabel({ obj, label }) { },
  //设置标记点偏移量
  setOffset({ obj, pixel }) { },
  //轨迹展示UI组件库
  pathSimplifier(config, callback) {
    //配置参数
    config = {
      data,//数据源数组
      zIndex,//绘制用图层的叠加顺序值 。如果需要叠加在地图的最上层，可以设置一个较大的值，比如300
      getPath,//返回轨迹数据中的路径信息
      getZIndex,
      getHoverTitle,
      //绘制引擎的构造参数
      renderOptions: {
        eventSupport,
        eventSupportInvisible,
        pathLineStyle: {
          strokeStyle,
          lineWidth,
          borderStyle,
          borderWidth,
          dirArrowStyle: true，//表示默认
          pathLineHoverStyle,
          pathLineSelectedStyle,
          keyPointStyle,
          hoverTitleStyle
        }
      },
    };
    //回调,回调参数为轨迹对象
    (pathSimplifierIns) => {
      //对象结构
      pathSimplifierIns = {
        currentObj,
        setData: Function,
        clearPathNavigators: Function,
        on,
        createPathNavigator: function (pathIndex, config) {
          return {
            start,
            pause,
            resume,
            stop,
          }
        }
      }
    }
  },

  //xun

  //轨迹移动
  moveAlong({ obj, circlable, lineArr, speed }) {
    //obj:点标记对象
    //circlable:[Boolean]是否循环，默认为false【可选】
    //speed:[Number] 移动速度
    //lineArray:[Array]轨迹路径的经纬度对象的数组
  },
  //停止移动
  stopMove({ obj }) {
    //obj:点标记对象
  },
  //暂停移动
  pauseMove({ obj }) {
    //obj:点标记对象
  },
  //继续移动
  resumeMove({ obj }) {
    //obj:点标记对象
  },
  //注册事件
  on({ eventName, callback, obj }) { },
  //poi搜索
  search(callback) {
    //callback:选择地址项后，触发的回调{location,adcode,district,address,name}
  },
  //打开测距openRangTool
  openRangTool({ addcallback, delcallback, endcallback }) {
    //距离量测结束后触发此事件，参数：
    //addcallback:每添加一个量测点时触发此事件,返回的res
    //marker：添加的标记点对象
    //position：添加的标记点坐标
    //type：事件类型为addnode

    //delcallback:每删除一个量测点时触发此事件,返回的res
    //target：距离量测对象
    //polyline：量测线对象
    //points：量测点（LngLat）对象的集合
    //distance: 本次距离量测的总距离值, 单位默认为：公里

    //endcallback:每添加一个量测点时触发此事件,返回的res
    //target：距离量测对象
    //polyline：量测线对象
    //points：量测点（LngLat）对象的集合
    //distance: 本次距离量测的总距离值, 单位默认为：公里

  },
  //打开鼠标工具功能
  openMouseTool({ type, callback }) {
    //type：鼠标绘制的类型，可选值为:
    //[circle(圆形） rectangel(矩形）polygon(多边形） measureArea（开启面积量测模式），polyline（折线）]
    //callback：绘制结束后的回调【可选】

    //type = circle参数data: 
    //圆形只有一个元素为中心点，其他为各个节点组成
    //points: Array类型
    //半径 圆形时有值，其他为0
    //radius：Number类型 （单位 / 米）

    //type = polygon和type = rectangel参数data
    //圆形只有一个元素为中心点，其他为各个节点组成
    //points: Array类型
    //半径 圆形时有值，其他为0
    //radius：Number类型
    //面积
    //area: Number类型(单位 / 平方米）

    //type = polyline参数data
    //圆形只有一个元素为中心点，其他为各个节点组成
    //points: Array类型
    //半径 圆形时有值，其他为0
    //radius：Number类型
    //折线的总长度
    //length类型(单位 / 米）
  },
  //关闭鼠标工具
  closeMouseTool() { },
  //创建形状覆盖物，并显示在地图上
  overLay({ type, points, radius }) {
    //type String 必填
    // type可选值 circle rectangle polygon polyline ellipse
    //返回覆盖物对象
    return shape;
  },
  //绘制线路
  drawRoute({ path, completeCallback, addwayCallback, type }) {
    //complete回调的数据结构
    //{points, routeObj, start,end,waypoints},
    //拖拽回调的数据结构
    //{lnglat, type, data},分别为拖拽产生的坐标对象，事件类型，线路数据
  },
  //摧毁线路
  destroyRoute({ obj }) {
    //obj:线路对象
  },
  //绘制行政区
  drawDistrict({ level, name, callback }) {
    //level:设置关键字对应的行政区级别或商圈，可选值：
    //country：国家,province：省 / 直辖市, city：市,district：区 / 县,  biz_area：商圈
    //name:根据关键字查询行政区或商圈信息 关键字支持：行政区名、citycode、adcode、商圈名

    //回调提供的数据,{status, result,shape}
  },
  //点聚合
  markerClusterer({ markers, gridSize, minClusterSize, maxZoom, styles, zoomOnClick, clickcallback }) {
    //markers：聚合点数组[mark1,mark2],
    //gridSize:聚合计算时网格的像素大小，默认60
    //minClusterSize：聚合的最小数量。默认值为2，即小于2个点则不能成为一个聚合
    //maxZoom：最大的聚合级别，大于该级别就不进行相应的聚合。默认值为18，即小于18级的级别均进行聚合，18及以上级别不进行聚合
    //zoomOnClick:点击聚合点时，是否散开，默认值为：true
    //clickcallback：点击事件 参数{cluster,lnglat,target,markers}
    //cluster：点击的聚合点对象，
    //lnglat：点击的位置点坐标，
    //target：点聚合插件对象，
    //marker：点击的聚合点所包含的点对象。
    //返回聚合对象
    return cluster;

  },
  //添加聚合点
  addClusterMarker({ obj, marker }) {
    //obj:聚合对象
    //marker:marker对象
  },
  //清除所有聚合对象
  clearClusterMarkers({ obj }) {
    //obj:聚合对象
  },
  //移除单个聚合点
  removeClusterMarker({ obj, marker }) {
    //obj:聚合对象
    //marker:marker对象
  },
  //获取聚合数量
  getClustersCount({ obj }) {
    //obj:聚合对象
  },
  //设置聚合计算的网格距离
  setClusterGridSize(config) {
    //config={obj:聚合对象,num:像素}
  },
  //设置聚合点
  setClusterMarkers(config) {
    //config={obj:聚合对象,markers:[{obj:聚合对象,marker:marker对象}]}
  },
  getClusterMarkers({ obj }) {
    //obj:聚合对象
    return [marker1, marker2];
    //marker 有currentObj，getOffset，setOffset，currentObj，getPosition，setPosition属性
  },
  //信息窗体
  infoWindow({ content, closecallback, opencallback, changecallback }) {
    //content： String / HTMLElement,【必填】
    //offset:偏移量【可选】
    //属性发生变化时changecallback 【可选】
    //信息窗体打开之后触发事件opencallback 【可选】
    //信息窗体关闭之后触发事件 【可选】
    //返回窗体对象
    return infoWindow;
  },
  //打开信息窗体
  openInfoWindow({ obj, position }) {
    //obj:信息窗体对象
    //position：LngLat坐标位置对象
  },
  //创建图层实体
  customLayer({ drawObj, options }) {
    //drawObj 绘制的对象
    //options={ zIndex,opacity,zooms,map}
    return customLayer;
  }
}
export default obj;
