import axios from 'axios';
import { Loading } from 'element-ui';
import { export_json_to_excel } from './DAOTable/Export2Excel';
import Vue from 'vue';
import { Message } from 'element-ui';
import router from '@/router';
import { hex_md5 } from './nMd5.js';
import sm2 from './Sm/sm2/index.js';
const decoder = new TextDecoder('utf-8');
const encoder = new TextEncoder();
//解决Json对象转字符串时将时区设定为UTC时间的问题
Date.prototype.toJSON = function () { return `${this.getFullYear()}-${this.getMonth() + 1}-${this.getDate()} ${this.getHours()}:${this.getMinutes()}:${this.getSeconds()}.${this.getMilliseconds()}`; };
let timeOutArr = Vue.prototype.timeOutArr;
let intervalArr = Vue.prototype.intervalArr;
// const sm2=require("./Sm/sm2/index.js")
let exp = {

  //初始化一个具备重试功能的axios对象
  getAxios: function (config) {
    if (this.isNull(config)) config = {};
    if (this.isNull(config.timeout)) config.timeout = 60000;

    let instance = axios.create(config);

    //发生网络错误时的重试次数
    if (!this.isNull(config.retry) && config.retry > 0)
      instance.defaults.retry = config.retry;
    else
      instance.defaults.retry = 0;

    //重试延迟
    if (!this.isNull(config.retryDelay) && config.retryDelay > 100)
      instance.defaults.retryDelay = config.retryDelay;
    else
      instance.defaults.retryDelay = 1000;

    instance.interceptors.response.use(undefined, function axiosRetryInterceptor(err) {
      var config = err.config;
      // If config does not exist or the retry option is not set, reject
      if (!config || !config.retry) return Promise.reject(err);
      // Set the variable for keeping track of the retry count
      config.__retryCount = config.__retryCount || 0;
      // Check if we've maxed out the total number of retries
      if (config.__retryCount >= config.retry) {
        // Reject with the error
        return Promise.reject(err);
      }
      // Increase the retry count
      config.__retryCount += 1;
      // Create new promise to handle exponential backoff
      var backoff = new Promise(function (resolve) {
        setTimeout(function () {
          resolve();
        }, config.retryDelay || 1);
      });
      // Return the promise in which recalls axios to retry the request
      return backoff.then(function () {
        return axios(config);
      });
    });

    return instance;
  },

  //默认http请求axios对象
  axiosInst: null,
  //退登，Code=9时表示当前用户登陆无效推出系统登陆
  logout: function () {
    this.setUser(null);
    this.setRouteCfg(null);
    window.sessionStorage.removeItem("roleFeature");
    window.sessionStorage.removeItem("roleTree");
    window.sessionStorage.clear();
  },
  //使用axios发起一个post请求
  post: function (url, data, callback, config) {
    let pConfig = { url: url, method: 'post', data: data };

    if (config) {
      pConfig.tkarr = config.tkarr;
      pConfig.tkstr = config.tkstr;
      pConfig.smOpt = config.smOpt;
      pConfig.headers = {};
    }
    this.http(pConfig, callback);
  },

  //使用axios发起一个get请求
  get: function (url, callback, config) {
    let gConfig = { url: url, method: 'get' };
    if (config) {
      gConfig.tkarr = config.tkarr;
      gConfig.tkstr = config.tkstr;
      gConfig.smOpt = config.smOpt;
      gConfig.headers = {};

    }
    this.http(gConfig, callback);
  },

  httpFunc: null,
  //使用axios发起一个http请求
  http: function (config, callback) {

    if (this.isNull(config.data))
      config.data = '';
    else {
      if (!this.isString(config.data))
        config.data = JSON.stringify(config.data);
    }
    this.tryCCITTEncHttpData(config);
    let invokeCallback = invokeRet => {
      //单独启动一个线程，避免DAOTable代码错误时，被捕获
      if (!this.isNull(callback))
        setTimeout(() => callback(invokeRet));
    }
    let axiosInst = config.axiosInst;
    if (this.isNull(axiosInst)) axiosInst = this.axiosInst;
    config.responseType = 'arraybuffer';
    let dataR = new Date().getTime() + 5;
    if (!config.headers) config.headers = {};
    //获取参数名称1
    let name1 = this.getName(1, [0, 1, 5, 7, 14, 20, 23, 29, 33]);
    config.headers[name1] = dataR;
    let op1 = dataR + 3 + "";
    let op2 = hex_md5(op1).toUpperCase();
    let op3 = hex_md5(op2 + "2").toUpperCase();
    //获取参数名称2
    let name2 = this.getName(0, [4, 10, 13, 15, 18, 21, 24, 27, 33, 37, 41]);
    config.headers[name2] = op3;
    if (this.httpFunc) this.httpFunc(this);
    axiosInst.request(config).then(resp => {
      if (resp.status != 200)
        invokeCallback({ Code: resp.status, Message: resp.statusText, Result: null, Resp: resp });
      else {
        this.NrailsRelease(resp, config.tkarr, config.tkstr);
        let data = resp.data;
        if (data.Code == 9) {
          try {
            //清除定时器
            this.loginExpired();
          } catch (e) {
            console.log(e);
          }
          return;
        }
        if (name1 && resp && resp.headers && resp.headers[name1]) {
          //解析应答报文的包是否携带请求参数，防止抓包注入应答，非法登录，应用于三级等保、微信小程序重复请求、非法接口调用
          name1 += "";
          let num = name1.charAt(name1.length - 1) - 0;
          if (num < 2) num = 2;
          let mdId = resp.headers[name1];
          let str = '';
          for (let i = 0; i < num; i++) {
            str += name1;
            str = hex_md5(str);
            str = str.toUpperCase();
          }
          //请求不一致
          if (str.toUpperCase() != mdId.toUpperCase()) {
            console.log(str, mdId, name1);
            invokeCallback({ Code: -2, Message: "数据体不符合标准", Result: null, Resp: null });
            return;
          }
        }
        if (!this.isNull(data.Code))
          invokeCallback({ Code: data.Code, Message: data.Message, Result: data.Result, Resp: resp });
        else
          invokeCallback({ Code: 0, Message: null, Result: data, Resp: resp });
      }
    }).catch(eor => {
      let errorMessage = eor.message;
      if (eor.code == "ECONNABORTED") {
        errorMessage = "请求超时，请重新请求";
      };
      invokeCallback({ Code: 503, Message: errorMessage, Result: null, Resp: null });
    });


  },
  httpAll(configArr, callback) {
    let reqArr = [];
    //获取参数名称1
    let name1 = this.getName(1, [0, 1, 5, 7, 14, 20, 23, 29, 33]);
    //获取参数名称2
    let name2 = this.getName(0, [4, 10, 13, 15, 18, 21, 24, 27, 33, 37, 41]);
    let dataR = "";
    let op3 = "";
    let lConfigs = [];
    for (let i = 0; i < configArr.length; i++) {
      let cItem = configArr[i];
      let axiosInst = cItem.axiosInst;
      let nItem = this.formateConfig(cItem, name1, name2);
      //设置统一的id
      if (dataR && op3) {
        nItem.headers[name1] = dataR;
        nItem.headers[name2] = op3;
      } else {
        dataR = nItem.headers[name1]
        op3 = nItem.headers[name2]
      }
      lConfigs.push(nItem);
      reqArr.push(axiosInst.request(nItem))
    }
    let config = lConfigs[0];
    let invokeCallback = (invokeRet1, invokeRet2) => {
      //单独启动一个线程，避免DAOTable代码错误时，被捕获
      if (!this.isNull(callback))
        setTimeout(() => callback(invokeRet1, invokeRet2));
    }
    axios.all(reqArr).then(axios.spread((res1, res2) => {
      // 两个请求现在都执行完成
      let resArr = [res1, res2]
      if (res1.status != 200 || res2.status != 200)
        invokeCallback({ Code: res1.status, Message: res1.statusText, Result: null, Resp: res1 },
          { Code: res2.status, Message: res2.statusText, Result: null, Resp: res2 }
        );
      else {
        this.NrailsRelease(res1, config.tkarr, config.tkstr);
        this.NrailsRelease(res2, config.tkarr, config.tkstr);
        let data1 = res1.data;
        let data2 = res2.data;
        if (data1.Code == 9 || data2.Code == 9) {
          try {
            //清除定时器
            this.loginExpired();
          } catch (e) {
            console.log(e);
          }
          return;
        }
        for (let i = 0; i < resArr.length; i++) {
          let res1 = resArr[i];
          if (name1 && res1 && res1.headers && res1.headers[name1]) {
            //解析应答报文的包是否携带请求参数，防止抓包注入应答，非法登录，应用于三级等保、微信小程序重复请求、非法接口调用
            name1 += "";
            let num = name1.charAt(name1.length - 1) - 0;
            if (num < 2) num = 2;
            let mdId = res1.headers[name1];
            let str = '';
            for (let i = 0; i < num; i++) {
              str += name1;
              str = hex_md5(str);
              str = str.toUpperCase();
            }
            //请求不一致
            if (str.toUpperCase() != mdId.toUpperCase()) {
              console.log(str, mdId, name1);
              invokeCallback({ Code: -2, Message: "数据体不符合标准", Result: null, Resp: null },
                { Code: -2, Message: "数据体不符合标准", Result: null, Resp: null },
              );
              return;
            }
          }
        }

        if (!this.isNull(data1.Code) || !this.isNull(data2.Code))
          invokeCallback(
            { Code: data1.Code, Message: data1.Message, Result: data1.Result, Resp: res1 },
            { Code: data2.Code, Message: data2.Message, Result: data2.Result, Resp: res2 },
          );
        else
          invokeCallback(
            { Code: 0, Message: null, Result: data1, Resp: res1 },
            { Code: 0, Message: null, Result: data2, Resp: res2 },
          );
      }
    })).catch(eor => {
      let errorMessage = eor.message;
      console.error(eor);
      if (eor.code == "ECONNABORTED") {
        errorMessage = "请求超时，请重新请求";
      };
      invokeCallback(
        { Code: 503, Message: errorMessage, Result: null, Resp: null },
        { Code: 503, Message: errorMessage, Result: null, Resp: null },
      );
    });;
  },
  formateConfig: function (config, name1, name2) {
    if (this.isNull(config.data))
      config.data = '';
    else {
      if (!this.isString(config.data))
        config.data = JSON.stringify(config.data);
    }
    this.tryCCITTEncHttpData(config);

    let axiosInst = config.axiosInst;

    config.responseType = 'arraybuffer';
    let dataR = new Date().getTime() + 5;
    if (!config.headers) config.headers = {};
    //获取参数名称1
    config.headers[name1] = dataR;
    let op1 = dataR + 3 + "";
    let op2 = hex_md5(op1).toUpperCase();
    let op3 = hex_md5(op2 + "2").toUpperCase();
    //获取参数名称2
    config.headers[name2] = op3;
    return config;
  },
  //隐式获取英文名称
  getName(index, arr) {
    let strs = ["9eW4odhRHrp34ecrlia4ht9jiq3ohrhNgni9qIehgdee", "rejkkq3u78cbc8edh39fs22t3A4FEI446dAq"];
    let ret = "";
    for (let i = 0; i < arr.length; i++) {
      ret += strs[index].substr(arr[i], 1);
    }
    return ret;
  },
  trySm2EncHttpData: function (config) {
    if (config.smOpt) {
      config.headers.smencrytype = "sm2";
      let dataStr = config.data;
      let cfg = { cipherMode: config.cipherMode };
      if (config.outType) cfg.output = config.outType;
      let encData = sm2.doEncrypt(dataStr, config.puk, cfg); // 加密结果
      config.data = encData;
      //console.log('加密', dataStr, encData)
      //let decData = sm2.doDecrypt(encData, config.pvk, { cipherMode: config.cipherMode }); // 加密结果
      //console.log('解密', encData, decData)

    }
  },
  tryHttpSm2Parse: function (ret, pvk, cipherMode) {
    if (ret.headers && ret.headers['smencrytype'] == 'sm2' && ret.data) {
      let enstr = ret.data;
      // if (enstr.indexOf('04') == 0) { enstr = enstr.slice(2); }
      let decData = sm2.doDecrypt(enstr, pvk, { cipherMode: cipherMode }); // 加密结果
      ret.data = JSON.parse(decData);
    }
  },
  tryCCITTEncHttpData(config) {
    if (config.smOpt) {
      config.headers.smencrytype = "CCITT";
      let tbuffer = encoder.encode(config.data);
      config.data = tbuffer.buffer;
      this.NrailsKeep(config.data, config.tkarr, config.tkstr)
    }
  },
  NrailsRelease(ret, tkarr, tkstr) {
    if (ret.headers && ret.headers['smencrytype'] && ret.data) {
      this.NrailsKeep(ret.data, tkarr, tkstr)
      let strData = decoder.decode(ret.data);

      ret.data = JSON.parse(strData);
    } else {
      let strData = decoder.decode(ret.data);
      ret.data = JSON.parse(strData);
    }
  },
  NrailsKeep(buffer, tkarr, tkstr) {
    var dataview = new DataView(buffer);
    let tkObj = {};
    for (let i = 0; i < tkstr.length; i++) {
      let name = tkstr[i];
      tkObj[name] = tkarr[i];
    }

    let key = tkObj.k;
    let M = tkObj.m;
    let A = tkObj.a;
    let C = tkObj.c;
    //let key = 0x2334;
    //let M = 0x2323;
    //let A = 0x2423;
    //let C = 0x2523;
    let offset = 0;
    let len = -1;
    if (len == -1) len = dataview.byteLength - offset;
    let end = offset + len;
    for (let i = offset; i < end; i++) {
      key = A * (key % M) + C;
      let num = dataview.getUint8(i);
      num = ((num ^ ((key >> 20) & 0xff))) & (0xff);
      dataview.setUint8(i, num);
    }
  },
  testFun() { },
  //用于承载loading
  loadingTargets: { IdSeed: 0, },
  loginExpired() {
    Message.error("账号已在其他地方登录");
    for (var time in timeOutArr) {
      clearTimeout(time);
    }
    for (var intval in intervalArr) {
      clearInterval(intval);
    }
    let entryUrl = this.getItem('entryUrl');
    console.log(router);
    if (entryUrl) {
      let path = entryUrl.split('/#')[1];
      router.push(path);
      this.logout();
    }
  },
  //显示加载框
  showLoading(target, text) {
    if (this.isNull(target)) {
      this.loadingTargets.loadingInstance = Loading.service({ target: target, text: text });
      return;
    }
    if (this.isNull(target.GUID)) target.GUID = "LD" + this.loadingTargets.IdSeed++;
    this.loadingTargets[target.GUID] = Loading.service({ target: target, text: text });
  },

  //关闭加载框
  closeLoading(target) {
    let loadingInstance = null;
    if (this.isNull(target))
      loadingInstance = this.loadingTargets.loadingInstance;
    else {
      if (!this.isNull(target.GUID))
        loadingInstance = this.loadingTargets[target.GUID];
    }
    if (!this.isNull(loadingInstance)) {
      loadingInstance.close();
      loadingInstance = null;
    }
  },

  //获取给定路径的文件名(包含扩展名）
  getFileName: function (path) {
    // 1.获取文件路径
    let newPath = path.replace(/\\/g, '/');
    // 2.截取文件名
    return newPath.substring(newPath.lastIndexOf("/") + 1, newPath.length);
  },

  //获取给定路径中的文件名（不包含扩展名）
  getFileNameWithoutExtension: function (path) {
    let fileName = this.getFileName(path);
    let idx = fileName.lastIndexOf(".");
    if (idx == -1)
      return fileName;
    else
      return fileName.substring(0, idx);
  },

  //判断给定的数据是否为空
  isNull: function (obj) {
    if (obj == undefined || obj == null || obj === "")
      return true;
    return false;
  },

  //true=给定的对象是一个函数
  isFunction: function (obj) {
    return obj != undefined && obj != null && typeof (obj) == "function";
  },

  //true=当前是调试模式
  isDebug: function () {
    return window.location.hostname == "localhost";
  },

  //true=给定的对象是字符串
  isString: function (data) {
    if (this.isNull(data))
      return false;
    else
      return Object.prototype.toString.call(data) == '[object String]';
  },

  //二维数组，查找某个数组是否存在在二维数组中
  inArray(arr, value, key) {
    if (arr.length === undefined) {
      throw new Error("inArray中的arr不是对象数组");
    }
    for (var i = 0; i < arr.length; i++) {
      if (JSON.stringify(arr[i]) == JSON.stringify(value)) {
        return i;
      }
    }
    return -1;
  },

  //获取两个坐标数组中变化的点
  getChange(pre, now) {
    let obj = {}
    if (JSON.stringify(pre) == JSON.stringify(now)) {
      obj.type = "equal";
      return obj;
    }
    if (pre.length < now.length) {
      obj.type = 'insert';
    }
    else if (pre.length > now.length) {
      obj.type = 'del';
    }
    else {
      let num = 0;
      for (var j = 0; j < now.length; j++) {
        for (var k = 0; k < pre.length; k++) {
          if (pre[k][0] == now[j][0] && pre[k][1] == now[j][1]) {
            num++;
          }
        }
      }
      if (num != now.length) {
        obj.type = "updata";
      } else {
        obj.type = "move";
      }
    }
    for (var i = 0; i < pre.length; i++) {
      //当为删除时，now最后一个点不存在，特殊处理
      if (!now[i] && obj.type == "del") {
        obj.index = i;
        break;
      }
      if (pre[i][0] != now[i][0] || pre[i][1] != now[i][1]) {
        obj.index = i;
        obj.lnglat = now[i];
        break;
      }
    }
    //如果是最后一个点新增，上面的循环将不会执行if里的语句，index将为undefined
    if (obj.index === undefined && obj.type == "insert") {
      //最后新增
      obj.index = pre.length;
      obj.lnglat = now[pre.length];
    }
    return obj;
  },

  //设置会话对象
  setItem: function (key, data) {
    let obj = {};
    obj.data = data;
    window.sessionStorage.setItem(key, JSON.stringify(obj));
  },
  setLocItem: function (key, data) {
    let obj = {};
    obj.data = data;
    window.localStorage.setItem(key, JSON.stringify(obj));
  },
  //设置会话对象
  removeItem: function (key, data) {
    window.sessionStorage.removeItem(key);
  },
  //设置会话对象
  removeLocItem: function (key, data) {
    window.localStorage.removeItem(key);
  },

  //获取会话对象
  getItem: function (key) {
    let str = window.sessionStorage.getItem(key);
    if (this.isNull(str))
      return str;
    var obj = JSON.parse(str);
    return obj.data;
  },
  //获取会话对象
  getLocItem: function (key) {
    let str = window.localStorage.getItem(key);
    if (this.isNull(str))
      return str;
    var obj = JSON.parse(str);
    return obj.data;
  },

  //查询URL地址中的参数
  getQueryString: function (name) {
    let reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
    let r = decodeURI(window.location.search).substr(1).match(reg);
    if (r != null) return unescape(r[2]); return null;
  },

  //判断字符是否为空(null或undefined或空字符串)
  isEmpty: function (string) {
    if (string == null || string == undefined) return true;
    return string === '';
  },

  isUint: function (number) {//正整数字符判断 
    let regx = /^\+?[1-9][0-9]*$/;
    return regx.test(number);
  },

  //获取目标对象的类型描述符
  getType: function (tar) {
    return Object.prototype.toString.call(tar);
  },

  //true=给定的对象是一个html元素
  isHTMLElement: function (tar) {
    let typeStr = this.getType(tar);
    return typeStr.indexOf('[object HTML') === 0 && typeStr.indexOf('Element]') > 0;
  },

  //克隆一个对象
  clone(obj) {
    if (this.isNull(obj)) return null;
    let jsonStr = JSON.stringify(obj);
    let fields = JSON.parse(jsonStr);
    return fields;
  },

  //大小变化执行器
  resizer: {
    eventAttetched: false,
    items: [],
    changeTick: 0,
    targetTick: 0,
    running: false,
    start(resizer) {
      if (this.eventAttetched) return;
      this.eventAttetched = true;
      setTimeout(() => this.checkSize(resizer, this.checkSize), 500);
    },

    checkSize(resizer, func) {

      for (let i = 0; i < resizer.items.length; i++) {
        let item = resizer.items[i];
        let parent = item.parent;
        console.log(item, parent.clientWidth, parent.clientHeight);
        if (item.pw !== parent.clientWidth || item.ph !== parent.clientHeight) {

          let dx = item.dx;
          let dy = item.dy;
          let callback = item.callback;

          let x = parent.clientWidth - dx;
          let y = parent.clientHeight - dy;
          let isFunction = item.isFunction;
          if (isFunction)
            callback(x, y);
          else {
            callback.width = x;
            callback.height = y;
          }
          item.pw = parent.clientWidth;
          item.ph = parent.clientHeight;
        }
      }
      setTimeout(() => func(resizer, func), 500);
    }
  },
  /**
   * 下载文件
   * @param {any} path 路径
   * @param {any} fileName 文件名，可指定（例如：'下载.mp3'）
   */
  download(path, fileName) {
    if (!fileName) {
      fileName = path.split("/")[path.split("/").length - 1];
    }
    fetch(path).then(res => res.blob().then(blob => {
      var a = document.createElement('a');
      var url = window.URL.createObjectURL(blob);
      a.href = url;
      a.download = fileName;
      a.click();
      window.URL.revokeObjectURL(path);
    }));
  },
  //根据页面大小和差值，自动计算目标大小
  autoSize: function (dx, dy, callback, ref) {
    let parent = null;
    if (this.isNull(ref))
      parent = document.documentElement;
    else
      parent = ref.$el;

    this.resizer.items.push(
      {
        pw: 0,
        ph: 0,
        parent,
        ref,
        dx,
        dy,
        callback,
        isFunction: this.isFunction(callback),
      });
    this.resizer.start(this.resizer);
  },

  /**
 * json 导出表格
 * @param {*} tHeader 
 * @param {*} list 
 * @param {*} filterVal 
 * @param {*} title 
 */
  exportExcel: function (tHeader, list, filterVal, title) {
    const data = list.map(function (v) {
      return filterVal.map(function (j) {
        if (j === 'timestamp') {
          return parseTime(v[j])
        } else {
          return v[j]
        }
      });
    });
    export_json_to_excel(tHeader, data, title)
  },

  /**
 * json 导出表格
 * @param {*} domName=id名称,，如boxWrap
 * @param {*} title =报表导出的名称
 */
  exportExcelDom(domName, title) {
    // 判断要导出的节点中是否有fixed的表格，如果有，转换excel时先将该dom移除，然后append回去，
    var fix = document.querySelector('.el-table__fixed');

    /* generate workbook object from table */
    var wb = XLSX.utils.table_to_book(document.getElementById(domName).removeChild(fix));
    document.getElementById(domName).appendChild(fix);
    /* get binary string as output */
    var wbout = XLSX.write(wb, { bookType: 'xlsx', bookSST: true, type: 'array' })
    try {
      window.saveAs(new Blob([wbout], { type: 'application/octet-stream' }), title + ".xlsx")
    } catch (e) { if (typeof console !== 'undefined') console.log(e, wbout) }
    return wbout
  },
  /**
 * @desc   格式化${startTime}距现在的已过时间
 * @param  {Date} startTime 
 * @return {String}
 */
  formatPassTime(startTime) {
    var currentTime = Date.parse(new Date()),
      time = currentTime - startTime,
      day = parseInt(time / (1000 * 60 * 60 * 24)),
      hour = parseInt(time / (1000 * 60 * 60)),
      min = parseInt(time / (1000 * 60)),
      month = parseInt(day / 30),
      year = parseInt(month / 12);
    if (year) return year + "年前"
    if (month) return month + "个月前"
    if (day) return day + "天前"
    if (hour) return hour + "小时前"
    if (min) return min + "分钟前"
    else return '刚刚'
  },

  /**
   * @desc   格式化现在距${endTime}的剩余时间
   * @param  {Date} endTime  
   * @return {String}
   */
  formatRemainTime(endTime) {
    var startDate = new Date(); //开始时间
    var endDate = new Date(endTime); //结束时间
    var t = endDate.getTime() - startDate.getTime(); //时间差
    var d = 0,
      h = 0,
      m = 0,
      s = 0;
    if (t >= 0) {
      d = Math.floor(t / 1000 / 3600 / 24);
      h = Math.floor(t / 1000 / 60 / 60 % 24);
      m = Math.floor(t / 1000 / 60 % 60);
      s = Math.floor(t / 1000 % 60);
    }
    return d + "天 " + h + "小时 " + m + "分钟 " + s + "秒";
  },
  /**
   * @desc 截取时间字符串去掉秒后面的点，
   * @param {string} date 如 2017-10-16 19:53:24.818839
   * @return{string} 截取返回 2017-10-16 19:53:24
   */
  subDate(date) {
    var stop = date.indexOf('.');
    if (stop < 0) return date;
    return date.substring(0, stop);
  },
  /**
   * @desc 去掉时间字符串中T字符
   * @param {string} date 如 2017-10-16T19:53:24
   * @return{string} 2017-10-16 19:53:24
   */
  removeDateT(date) {
    return date.replace(/T/g, ' ');
  },

  /**
   * @desc 如 2017-10-16 19:53:24.818839，截取返回 2017-10-16 19:53:24 去掉去掉时间字符串中T字符
   * @param {string} date 如 2017-10-16T19:53:24.818839
   * @return {string }2017-10-16 19:53:24
   */
  subAndRemoveDate(date) {
    return this.removeDateT(this.subDate(date));
  },
  /**
   * 一天的毫秒数
   */
  totalMillisecondOfDay: 24 * 60 * 60 * 1000,
  /**
   * 一个小时的毫秒数
   */
  totalMillisecondOfHour: 60 * 60 * 1000,
  /**
   * 一分钟的毫秒数
   */
  totalMillisecondOfMinute: 60 * 1000,
  /**
   * 一秒钏的毫秒数
   */
  totalMillisecondOfSecond: 1000,

  ///**
  // * 为时间对象加/减指定的天数，返回新的时间对象
  // * param {dateTime} 时间对象 
  // * param {nDays}天数  
  // * returns {Date}
  // */
  dateTimeAddDays: function (dateTime, nDays) {
    //当前日期的毫秒数 + 天数 * 一天的毫秒数
    var mseconds = dateTime.getTime() + nDays * this.totalMillisecondOfDay;
    var newDate = new Date(mseconds);
    return newDate;
  },

  ///**
  // * 为时间对象加/减指定的小时，返回新的时间对象
  // * @param {时间对象}  dateTime
  // * @param {小时}  nHours
  // */
  dateTimeAddHours: function (dateTime, nHours) {
    //当前日期的毫秒数 + 小时数 * 一小时的毫秒数
    var mseconds = dateTime.getTime() + nHours * totalMillisecondOfHour;
    var newDate = new Date(mseconds);
    return newDate;
  },

  ///**
  // * 为时间对象加/减指定的分钟，返回新的时间对象
  // * @param {时间对象}  dateTime
  // * @param {分钟}  nMinutes
  // */
  dateTimeAddMinutes: function (dateTime, nMinutes) {
    //当前日期的毫秒数 + 分钟数 * 一分钟的毫秒数
    var mseconds = dateTime.getTime() + nMinutes * totalMillisecondOfMinute;
    var newDate = new Date(mseconds);
    return newDate;
  },

  ///**
  // * 为时间对象加/减指定的秒数，返回新的时间对象
  // * @param {时间对象}  dateTime
  // * @param {秒数}  nSeconds
  // */
  dateTimeAddSeconds: function (dateTime, nSeconds) {
    //当前日期的毫秒数 + 秒数 * 一秒钟的毫秒数
    var mseconds = dateTime.getTime() + nSeconds * this.totalMillisecondOfSecond;
    var newDate = new Date(mseconds);
    return newDate;
  },





  ///**
  //* 返回时间对象当天的开始时间对象，即yyyy-MM-dd 00:00:00
  //* @param {时间对象} dateTime 
  //*/
  dateTimeBegin: function (dateTime) {

    return new Date(dateTime.getFullYear(), dateTime.getMonth(), dateTime.getDate());
  },
  ///**
  //* 返回时间对象当天的最后时间对象，即yyyy-MM-dd 23:59:59
  //* @param {时间对象} dateTime 
  //*/
  dateTimeEnd: function (dateTime) {

    return new Date(dateTime.getFullYear(), dateTime.getMonth(), dateTime.getDate(), 23, 59, 59);
  },

  ///**
  //* 返回时间对象当前周的开始日期时间，时间部分为 0时 0分 0秒
  //* @param {时间对象} dateTime 
  //*/
  dateTimeOfWeekBegin: function (dateTime) {

    var begin = dateTimeBegin(dateTime);
    //根据本地时间返回指定日期对象的星期中的第几天（0-6）
    var day = begin.getDay();

    var weekBegin = null;
    if (day === 0) day = 6;
    weekBegin = dateTimeAddDays(begin, -(day - 1));
    return weekBegin;
  },
  ///**
  //* @desc 对时间进行替换，-替换/，T替换空去掉秒. 例如 2006-07-02T08:09:04.423 转换后 2006/07/02 08:09:04
  //* @param {时间字符串} strDateTime 
  //* @returns{dataTime}
  //*/
  dateTimeReplace: function (strDateTime) {
    return new Date(this.subDate(strDateTime.replace(/-/g, '/').replace(/T/g, ' ')));;
  },

  ///**
  // * 对Date的扩展，将 Date 转化为指定格式的String
  // * 月(M)、日(d)、小时(h)、分(m)、秒(s)、季度(q) 可以用 1-2 个占位符，
  // * 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)  
  // * 例子： 
  // * (new Date()).Format("yyyy-MM-dd HH:mm:ss.S") ==> 2006-07-02 08:09:04.423 
  // * (new Date()).Format("yyyy-M-d H:m:s.S")      ==> 2006-7-2 8:9:4.18 
  // * 
  // * @param {时间对象} dateTime 
  // * @param {格式化字符串} fmt 
  // */
  dateTimeFormat: function (dateTime, fmt) {
    var o = {
      "M+": dateTime.getMonth() + 1, //月份 
      "d+": dateTime.getDate(), //日 
      "H+": dateTime.getHours(), //小时 
      "m+": dateTime.getMinutes(), //分 
      "s+": dateTime.getSeconds(), //秒 
      "q+": Math.floor((dateTime.getMonth() + 3) / 3), //季度 
      "S": dateTime.getMilliseconds() //毫秒 
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (dateTime.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
      if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
  },

  ///**
  // * 返回时间对象当前周的最后日期时间，时间部分为 23时 59分 59秒
  // * @param {时间对象} dateTime 
  // */
  dateTimeOfWeekEnd: function (dateTime) {

    var end = dateTimeEnd(dateTime);
    //根据本地时间返回指定日期对象的星期中的第几天（0-6）
    var day = end.getDay();

    if (day > 0) {
      var ndays = 7 - day;
      return dateTimeAddDays(end, ndays);
    } else {
      return end;
    }
  }
};

exp.axiosInst = exp.getAxios({
  headers: {
    post: {
      'Content-Type': 'application/json'
    },
  },
});

export default exp;
